var sqlite3 = require('sqlite3');
var open = require('sqlite').open;

var repository = {
    create: async (entity) => {
        // Inserts entity in db table, id should be missing and autogenerated
        const db = await open({
            filename: '../database.db',
            driver: sqlite3.Database
        });

        let correct_answer = await db.run('INSERT INTO correct_answer (answer_id, question_id) VALUES (@answer_id, @question_id)',
            { '@answer_id': entity.answer_id, '@question_id': entity.question_id });

        await db.close();
        return correct_answer;
    },
    update: async (entity) => {
        // Updates entity of given id in db table
    },
    delete: async (id) => {
        // Deletes entity of given id from db table
        const db = await open({
            filename: '../database.db',
            driver: sqlite3.Database
        });

        let result = await db.run('DELETE FROM correct_answer WHERE id = @id',
            { '@id': id });

        await db.close();
        return result;
    },
    exists: async (id) => {
        // Returns True if entity with given id exists in db table, false otherwise
        const db = await open({
            filename: '../database.db',
            driver: sqlite3.Database
        });

        const stmt = await db.prepare('SELECT * FROM correct_answer WHERE id = @id',
            { '@id': id });

        let result = await stmt.get();
        await stmt.finalize();

        await db.close();
        return result != null;
    },
    count: async () => {
        // Returns total number of entities in db table
        const db = await open({
            filename: '../database.db',
            driver: sqlite3.Database
        });

        const stmt = await db.prepare('SELECT * FROM correct_answer');

        let result = await stmt.all();
        await stmt.finalize();

        await db.close();
        return result.length;
    },
    findById: async (id) => {
        // Returns entity with given id from db table, null if not existent
        const db = await open({
            filename: '../database.db',
            driver: sqlite3.Database
        });

        const stmt = await db.prepare('SELECT * FROM correct_answer WHERE id = @id', { '@id': id });

        let result = await stmt.get();
        await stmt.finalize();

        await db.close()
        return result;
    },
    findByQuestion: async (id) => {
        const db = await open({
            filename: '../database.db',
            driver: sqlite3.Database
        });

        const stmt = await db.prepare('SELECT * FROM correct_answer WHERE question_id = @question_id', { '@question_id': id });

        let result = await stmt.all();
        await stmt.finalize();

        await db.close()
        return result;
    },
    getAll: async () => {
        // Returns all entites from db table
        const db = await open({
            filename: '../database.db',
            driver: sqlite3.Database
        });

        const stmt = await db.prepare('SELECT * FROM correct_answer');

        let result = await stmt.all();
        await stmt.finalize();

        await db.close()
        return result;
    },
}

module.exports = repository;